// common head for remote control module at RCX end
//
// Single Author info: 
//
// username: Xuejun Sun
// Group 4
// 
// Group info:
//
// username: Haigui Huang
// 
//==========================================================
#include <unistd.h>
#include <conio.h>
#include <dmotor.h>
#include <dsound.h>


#ifndef MY_REMOTE // _PARAMETER_HERE // this need to be globol
#define MY_REMOTE // _PARAMETER_HERE

int curSpeed;			// current motor speed

int speedStep = 8;		// increament/decrement speed step

unsigned char stateSpeed;	// state of motor: f, b, s

unsigned char turnRate;		// turnning speed

unsigned char turnPressNum;	// times of contineous turning button press

const unsigned char bit0 = 0x00;// Forward
const unsigned char bit1 = 0x40;// backward
const unsigned char bit2 = 0x80;// left-turn
const unsigned char bit3 = 0xc0;// right-turn

unsigned char comMsg;		// message sent out from RCX

long curTime;				//  = sys_time;
long timeOut; // = TIME_OUT_MSEC;		// time out value
#endif
