//
//  FrameCallBackThread.java
//  macam
//
//  Created by Haihui Huang on Thu Dec 05 2002.
//  Copyright (c) 2002 __MyCompanyName__. All rights reserved.
//

import quicktime.app.sg.*;
import quicktime.std.sg.*;
import quicktime.util.*;
import quicktime.std.*;
import quicktime.*;
import java.io.*;
import java.net.*;

public class FrameCallBackThread extends Thread implements SGCaptureCallback, SGDataProc {
    public static byte[] imgBuf = new byte[230400];
    public static int frameNo = 0;
    public static int frameSize = 0;
    public static int framePos = 0;
    public static int bytesLeft = 0;
    public static DatagramSocket socket = null; //new DatagramSocket();
    public static DatagramPacket packet = null;// = new DatagramPacket(buf, buf.length, address, 4445);
    public static InetAddress address = null;  //= InetAddress.getByName("192.168.0.2");
    public static String inetAddrStr = new String(""); 
    
	public FrameCallBackThread(String str) {
		super(str);
        inetAddrStr = str;
	}
	public void run() {
		try{
            System.out.println("FrameCallBackThread started");
            socket = new DatagramSocket();                  // UDP client socket
			//address = InetAddress.getByName("192.168.0.2");
            //address = InetAddress.getByName("127.0.0.1");
            address = InetAddress.getByName(inetAddrStr);
            if( inetAddrStr != null)
                System.out.println( "UDP broadcast to " + inetAddrStr );
            else
                System.out.println( "Unknown broadcast address");
            
            while(true)
			{
				//sleep(10);
				yield();
			}
		}catch( Exception e){
            e.printStackTrace(); 
		}
	}

	//Called when the SequenceGrabber has completed capturing.
	public void finish(SGDrawer sg){
		System.out.println("Grab finished");
        // Send data via TCP/IP here
        // restart recording
        //sg.getSequenceGrabber().
        //SGControlPanel.showMovie();
	}
            // Sequence Graber DataProc
	public int execute(SGChannel chan, QTPointerRef dataToWrite, int offset, int chRefCon, int time, int writeType) {

            if(chan.getClass().getName().equals("quicktime.std.sg.SGVideoChannel") && writeType == StdQTConstants.seqGrabWriteAppend) {
                //Wrap the data with a RawEncodedImage Object
               try{
                   frameSize = dataToWrite.getSize();
                   frameNo ++;
				   if( frameNo%5 == 0 ) // send out data every 5 frames
				   {
                    System.out.print("\r" + frameNo + "-" + frameSize);
    
                    dataToWrite.copyToArray(offset, imgBuf, 0, frameSize);
                    /*
                	File outputFile = new File( (new Integer(frameNo).toString() ) + ".jpg");
                    outputFile.createNewFile();
                    FileOutputStream out = new FileOutputStream(outputFile);
                    out.write(imgBuf, 0, dataToWrite.getSize() );

                    out.close();
                    */
                    
                    for(framePos = 0; framePos < frameSize; framePos += 1400 )
                    {   bytesLeft = frameSize - framePos;
                        //System.out.println(" "+bytesLeft);
                        if( bytesLeft >= 1400 )
                            packet = new DatagramPacket(imgBuf, framePos,  1400, address, 7776);
                        else if( bytesLeft > 0 )
                            packet = new DatagramPacket(imgBuf, framePos,  
                                            bytesLeft, address, 7776);
                        if (bytesLeft > 0 )     
                            socket.send(packet);
                    }
				   }
               //} catch(StdQTException e) {
               //     e.printStackTrace();
                } catch(Exception e0) {
                    e0.printStackTrace();
                }
            }
            return 0;
	}
}
